      SUBROUTINE EM3C2C(NNO,NPO,X,Y,Z,NPI,IJT,POIDS,VP,VDPQ1,RO,AE,    
     +                  DELTA)
C  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C  BUT :   CALCUL DE LA MATRICE ELEMENTAIRE DE MASSE 
C  ---     
C  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C  PARAMETRES D'ENTREE :
C  -------------------
c  NNO          : nombre de points (interpolation des fonctions)
c  NPO          : nombre de points (interpolation de la geometrie)
C  X,Y,Z       : COORDONNEES DES NOEUDS DE L ELEMENT
C  RO          : MASSE VOLUMIQUE CONSTANTE SUR L ELEMENT
C  IJT         : PERMUTATION
C  NPI         : NOMBRE DE POINTS DE LA FORMULE D INTEGRATION
C  POIDS       : POIDS DE LA FORMULE D INTEGRATION SUR LE CUBE
C  VDPQ1       : VALEURS DES DERIVES DES POLYNOMES DE BASE 
C                AUX POINTS D INTEGRATION (geometrie)
C  VP          : VALEURS DES POLYNOMES DE BASE (Fonctions)
C                AUX POINTS D INTEGRATION
C  PARAMETRES RESULTATS :
C  --------------------
C  AE          : MATRICE ELEMENTAIRE DE MASSE STOCKEE SYMETRIQUE
C  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C  PROGRAMMEURS  : Marina Vidrascu INRIA septembre 2001
C  ..................................................................
      DOUBLE PRECISION  X(NPO),Y(NPO),Z(NPO)
      DOUBLE PRECISION POIDS(NPI),RO,AE(*),DELTA(NPI),VDPQ1(3,NPO,NPI),
     +        VP(NNO,NPI), DFINV(3,3),DF(3,3),zero

      parameter (zero = 0.)
      INTEGER IJT( *)

c     --- non utilises ---

      DOUBLE PRECISION a2(1),fi(1),XINT(1),YINT(1),ZINT(1)
C
      NM=NNO*3*(NNO*3+1)/2
      call dcopy(nm,zero,0,ae,1)
      INDICE = 0
      CALL FOBASE(3,3,NNO,NPO,NPI,VP,VP,VDPQ1,VDPQ1,X,Y,Z, A2,
     +            XINT,YINT,ZINT,DELTA,DFINV,DF,INDICE,fi,fi,fi,iopt)
C

         DO 11 J=1,NNO
         DO 11 I=1,J
C
C          BLOC 11
C          -------
           II = MIN(IJT(I),IJT(J))
           JJ = MAX(IJT(I),IJT(J))
           K1  = JJ*(JJ-1)/2+II
C
C          BLOC 22
C          -------
           II = MIN(IJT(NNO+I),IJT(NNO+J))
           JJ = MAX(IJT(NNO+I),IJT(NNO+J))
           K2 = JJ*(JJ-1)/2+II
C
C          BLOC 33
C          -------
           II = MIN(IJT(2*NNO+I),IJT(2*NNO+J))
           JJ = MAX(IJT(2*NNO+I),IJT(2*NNO+J))
           K3 = JJ*(JJ-1)/2+II

           DO 11 L=1,NPI
             AE(K1) = ae(k1) +VP(J,L) * VP(I,L) * POIDS(L) *DELTA(L)*ro
             AE(k2) = ae(k2) +VP(J,L) * VP(I,L) * POIDS(L) *DELTA(L)*ro
             AE(K3) = ae(k3) +VP(J,L) * VP(I,L) * POIDS(L) *DELTA(L)*ro
   11 CONTINUE
      END
